from _Framework.ChannelStripComponent import ChannelStripComponent
from MrSysex import MrSysex

#This is a custom version of the Live ChannelStripComponent
class MrChannelStripComponent(ChannelStripComponent):
    #Here is a new strip initiated and given an id
    def __init__(self, id):
        ChannelStripComponent.__init__(self)
        self._track_id = id
        return
    #This method is called to re-initiate the strip in lemur
    def _send_init(self):
        self._send_state()
    #This method sends the track id and name in sysex to lemur
    def _send_state(self):
        sysex = MrSysex('TRACK')
        sysex.byte(self._track_id)
        sysex.ascii(self._track is not None and self._track.name or '')
        if self._track in self.song().tracks:
            sysex.ascii(str(list(self.song().tracks).index(self._track) + 1))
        elif self._track in self.song().return_tracks:
            sysex.ascii(
                chr(list(self.song().return_tracks).index(self._track) + 65))
        else:
            sysex.ascii(' ')
        sysex.send()
        
