from _Framework.ControlSurface import ControlSurface
from _Framework.InputControlElement import *
from MrSysex import MrSysex
from MrMixerComponent import MrMixerComponent
from const import *

class MrLemur(ControlSurface):
	#This method initiates the ControlSurface
	def __init__(self, c_instance):
		ControlSurface.__init__(self, c_instance)
		self._setupMrLemur()
	#This method setups lemur and creates the needed components
	def _setupMrLemur(self):
		self.set_suppress_rebuild_requests(True)
		self._suppress_session_highlight = True
		self._suppress_send_midi = True
		MrSysex.set_midi_callback(self._send_midi)
		MrSysex.set_log(self.log_message)
		self._mixer = MrMixerComponent(NUM_TRACKS)
		for component in self.components:
			component.set_enabled(False)
		self.set_suppress_rebuild_requests(False)
		self.refresh_state()
		self._mixer._send_init()
		self.show_message("Let's Go!")

	def refresh_state(self):
		ControlSurface.refresh_state(self)
		self.schedule_message(5,self._init)
	#Initiates the controlsurface and enables the components
	def _init(self):
		self._suppress_send_midi = False
		self._suppress_session_highlight = True
		for component in self.components:
			component.set_enabled(True)
	#Suggests Daemon Input port as standard Input		
	def suggest_input_port(self):
	    return 'Daemon Input '
	#Suggests Daemon Output port as standard Ouput    
	def suggest_output_port(self):
	    return 'Daemon Output '
	#This method receives sysex and sends it to the corresponding controller    
	def handle_sysex(self,sysex):
	    if(sysex[1] == MIXER_SYSEX):
	        self._mixer.handle_sysex(sysex[1:])
	
	def _do_send_midi(self,midi_event_bytes):
	    if not self._suppress_send_midi:
	        self._c_instance.send_midi(midi_event_bytes)
	        return True
